Hash & Checksum Verifier
Check downloads against their published checksum — and verify the checksum file’s own OpenPGP or minisign signature, so you know who published it.
How to use
- Single file: drop it and paste the published checksum.
- Signed release: add the publisher’s key, the checksum list and its signature, then your downloads.
- Compare the key fingerprint shown with the one on the publisher’s website.
Drop a file here, or
Read in 4 MB pieces straight from your disk. Files over 1 GB work with MD5, SHA-1 and SHA-256.
A checksum proves less than you think
A matching SHA-256 proves that your file is identical to the one the checksum was made from. It does not prove who made either: an attacker who can replace a download on a mirror can usually replace the checksum next to it. That is why projects sign their checksum list with OpenPGP or minisign, and why this tool verifies that signature as well.
The chain of trust for a release
Verifying a signed release has three links: the file matches its line in SHA256SUMS, SHA256SUMS carries a valid signature, and the signing key really belongs to the publisher. The first two are checked here. The third is yours: compare the key fingerprint shown with the one published on the project’s website, documentation or a source you already trust — once, and then keep the key.
Which algorithm to trust
SHA-256 and SHA-512 are the standard for downloads. MD5 and SHA-1 still catch accidental corruption, but both have practical collision attacks (SHA-1 since the 2017 SHAttered result), so a match does not rule out deliberate tampering. The algorithm is detected from the checksum’s length. Large files are hashed in pieces in your browser, so multi-gigabyte ISO images work without being uploaded anywhere.
Where to find the pieces: Ubuntu and Debian publish SHA256SUMS next to the image, with its signature as SHA256SUMS.gpg (Ubuntu) or SHA256SUMS.sign (Debian); projects that use minisign publish a .minisig file and a public key starting with RW.
Common questions
How do I verify a file’s SHA-256 checksum?
Drop the file and paste the checksum from the download page. The algorithm is detected from its length, and you get a clear match or mismatch. Large files are read in pieces, so multi-gigabyte ISOs work.
Is a matching checksum enough?
It proves the file matches the list, not that the list is genuine — an attacker who changes the download can change the checksum too. Verifying the list’s signature with the publisher’s key closes that gap.
Is my file uploaded?
No. Your browser reads the file from your disk, and the page cannot open any connection to send it.
Known limitations
- You supply the publisher’s key — check its fingerprint at an official source.
- OpenPGP v4 RSA and Ed25519 only; key expiry and revocation aren’t checked.
- MD5 and SHA-1 catch corruption, not tampering. SHA-384/512 up to 1 GB.
- Browser extensions can read any page — use a private window for sensitive data. How the lock works
Related reading on CipherMind
Standards & references
- FIPS 180-4 — SHA-1 and SHA-2 (opens in a new tab)
- RFC 9580 — OpenPGP (opens in a new tab)
- minisign signature format (opens in a new tab)
- RFC 7693 — BLAKE2 (opens in a new tab)
- RFC 2104 — HMAC (opens in a new tab)